;  Start of PLAYER

PlayerFire      ld a,0                          ;
PFDel           equ .-1                         ;

                dec a                           ;
PFa             ld (PFDel),a                    ;

                and $03                         ;
                ret nz                          ;

                call kFire                      ;
                ld a,1                          ;
                jr z,PFa                        ;

                ld bc,0                         ;

                ld de,0                         ;

                ld hl,$0200                     ;

                exx                             ;

                ld hl,(FireDZ)                  ;
                ld de,(FireDX)                  ;
                ld bc,(FireDY)                  ;

                exx                             ;

                ld a,tProj                      ;
                jp CreateObject                 ;

AlterSteps      ld de,(XTurn)                   ;

                ld bc,0                         ;

                bit 7,d                         ;
                jr z,AX1                        ;

                dec bc                          ;

AX1             ld hl,(XTurnSum)                ;
                add hl,de                       ;
                ld (XTurnSum),hl                ;

                ld hl,(XTurnSum+2)              ;
                adc hl,bc                       ;
                ld (XTurnSum+2),hl              ;

                ld hl,(CellCount)               ;
                inc hl                          ;
                ld (CellCount),hl               ;

                call kDeccel                    ;
                jr nz,AlterSteps0               ;
                call kAccel                     ;
                jr z,AlterSteps2x               ;

                ld de,Zdvacc                    ;
                jr AlterSteps1                  ;

AlterSteps0     ld de,Zdvdec                    ;

AlterSteps1     ld hl,(DeltaZ)                  ;
                add hl,de                       ;

                ld de,MinSP                     ;
                or a                            ;
                sbc hl,de                       ;
                jp p,AlterSteps2                ;

                add hl,de                       ;
                ld de,MaxSP                     ;
                or a                            ;
                sbc hl,de                       ;
                jp m,AlterSteps2                ;

                add hl,de                       ;

                ex de,hl                        ;

AlterSteps2     ex de,hl                        ;
                ld (DeltaZ),hl                  ;

AlterSteps2x    equ *

        if not enabled Original

                ld a,(bUseAnalogJS)             ; Are we using the joystick for L/R/U/D?
                or a                            ;
                jp z AS_Keys                    ; No, skip

                ; Use the analog joystick

                ; Get X

                ld bc,$FBDF                     ; JoyX
                in l,(c)                        ;
                ld h,0                          ;
                bit 7,l                         ;
                jr z ASX_1                      ;
                dec h                           ;
ASX_1           add hl,hl                       ;

                ld (XTurn),hl

                ; Get Y

                ld bc,$FFDF                     ; JoyY
                in l,(c)                        ;
                ld h,0                          ;
                bit 7,l                         ;
                jr z ASY_1                      ;
                dec h                           ;
ASY_1           add hl,hl                       ;

                ld (YTurn),hl                   ;

                ; Right, assume that's done

                jp AlterSteps4

;

AS_Keys         equ *
        endif




                call kLeft                      ;
                jr nz,AlterSteps2k              ;

                call kRight                     ;
                jp z,AlterSteps3x               ;

                ld a,2                          ;
                jr AlterSteps21                 ;

AlterSteps2k    call kRight                     ;
                jr nz,AlterSteps3x              ;

                ld a,1                          ;
AlterSteps21    ld b,a                          ;
                ld a,(OldX)                     ;
                cp b                            ;
                jr z,AlterSteps2a               ;

                ld hl,Xdtstep                   ;
                ld (Xvar),hl                    ;

AlterSteps2a    ld hl,(Xvar)                    ;
                ld de,dDX                       ;
                add hl,de                       ;
                ld (Xvar),hl                    ;

                ex de,hl                        ;
                ld hl,(XTurn)                   ;
                ld a,b                          ;
                ld (OldX),a                     ;

                bit 0,a                         ;
                call ASMakeTurn                 ;
                ld (XTurn),hl                   ;
                jr AlterSteps3                  ;

AlterSteps3x    ld de,Xdtstep                   ;
                ld (Xvar),de                    ;

AlterSteps3     call kUp                        ;
                jr nz,AlterSteps3k              ;

                call kDown                      ;
                jr z,AlterSteps4x               ;

                ld a,2                          ;
                jr AlterSteps31                 ;

AlterSteps3k    call kDown                      ;
                jr nz,AlterSteps4x              ;

                ld a,1                          ;
AlterSteps31    ld b,a                          ;
                ld a,(OldY)                     ;
                cp b                            ;
                jr z,AlterSteps3a               ;

                ld hl,Ydtstep                   ;
                ld (Yvar),hl                    ;

AlterSteps3a    ld hl,(Yvar)                    ;
                ld de,dDY                       ;
                add hl,de                       ;
                ld (Yvar),hl                    ;

                ld a,b                          ;
                ld (OldY),a                     ;

                bit 0,a                         ;
                ex de,hl                        ;

                ld hl,(YTurn)                   ;
                call ASMakeTurn                 ;
                ld (YTurn),hl                   ;
                jr AlterSteps4                  ;

AlterSteps4x    ld hl,Ydtstep                   ;
                ld (Yvar),hl                    ;

AlterSteps4     ld a,(YTurn+1)                  ;
                bit 7,a                         ;
                jr z,AlterSteps4a               ;

                ld hl,HighY                     ;
                call Inner                      ;
                jr nz,AlterSteps5               ;

                jr AlterSteps4c                 ;

AlterSteps4a    ld hl,LowY                      ;
                call Inner                      ;
                jr z,AlterSteps5                ;

AlterSteps4c    ld (YTurn),hl                   ;

AlterSteps5     ld hl,(DeltaZ)                  ;
                ld de,(YTurn)                   ;
                add hl,hl                       ;
                add hl,hl                       ;
                add hl,hl                       ;
                add hl,hl                       ;

                call SignMult                   ;

                sra h                           ;
                rr l                            ;
                sra h                           ;
                rr l                            ;
                sra h                           ;
                rr l                            ;
                sra h                           ;
                rr l                            ;

                ld (DeltaY),hl                  ;

                Neg_HL()                        ;
                add hl,hl                       ;
                ld (FireDY),hl                  ;

                ld de,(XTurn)                   ;
                ld hl,(DeltaZ)                  ;

                add hl,hl                       ;
                add hl,hl                       ;
                add hl,hl                       ;
                add hl,hl                       ;

                call SignMult                   ;

                sra h                           ;
                rr l                            ;
                sra h                           ;
                rr l                            ;
                sra h                           ;
                rr l                            ;
                sra h                           ;
                rr l                            ;

                ld (DeltaX),hl                  ;

                Neg_HL()                        ;
                add hl,hl                       ;
                ld (FireDX),hl                  ;

                ld hl,(DeltaZ)                  ;
                Neg_HL()                        ;
                add hl,hl                       ;
                ld (FireDZ),hl                  ;

                ld de,ProjSP                    ;
                or a                            ;
                sbc hl,de                       ;
                or a                            ;
                bit 7,h                         ;
                ret z                           ;

                ld (FireDZ),de                  ;
                ld hl,ProjSP                    ;
                ld de,(YTurn)                   ;

                add hl,hl                       ;
                add hl,hl                       ;
                add hl,hl                       ;
                add hl,hl                       ;

                call SignMult                   ;

                sra h                           ;
                rr l                            ;
                sra h                           ;
                rr l                            ;
                sra h                           ;
                rr l                            ;
                sra h                           ;
                rr l                            ;

                ld (FireDY),hl                  ;

                ld hl,ProjSP                    ;
                ld de,(XTurn)                   ;

                add hl,hl                       ;
                add hl,hl                       ;
                add hl,hl                       ;
                add hl,hl                       ;

                call SignMult                   ;

                sra h                           ;
                rr l                            ;
                sra h                           ;
                rr l                            ;
                sra h                           ;
                rr l                            ;
                sra h                           ;
                rr l                            ;

                ld (FireDX),hl                  ;

                or a                            ;
                ret                             ;

Inner           ld de,(GroundY)                 ;
                or a                            ;
                sbc hl,de                       ;

                sra h                           ;
                rr l                            ;
                sra h                           ;
                rr l                            ;

                ld de,(DeltaZ)                  ;
                ex de,hl                        ;

                add hl,hl                       ;
                add hl,hl                       ;
                add hl,hl                       ;
                add hl,hl                       ;

                ex de,hl                        ;
                call SignDiv                    ;

                add hl,hl                       ;
                add hl,hl                       ;
                add hl,hl                       ;
                add hl,hl                       ;

                ld de,(YTurn)                   ;
                or a                            ;
                sbc hl,de                       ;

                bit 7,h                         ;
                add hl,de                       ;

                ret                             ;

Xvar            defw 3                          ;

AS4y            ld de,Ydtstep                   ;
                ld (Yvar),de                    ;
                jp AlterSteps4                  ;

Yvar            defw 1                          ;

OldX            defs 1                          ;
OldY            defs 1                          ;

ASMakeTurn      jr z,ASMT1                      ;

                Neg_DE()                        ;

ASMT1           add hl,de                       ;
                bit 7,h                         ;
                jr nz,ASMT2                     ;

                dec h                           ;
                inc h                           ;
                ret z                           ;

                ld hl,$00FF                     ;

                ret                             ;

ASMT2           inc h                           ;
                jr nz,ASMT2a                    ;

                dec h                           ;
                ret                             ;

ASMT2a          ld hl,$FF00                     ;
                ret                             ;

DrawSights      ld de,(XTurn)                   ;

                ld a,(CType)                    ;
                add a,SightClipY & $FF        ;
                ld l,a                          ;

                ld a,SightClipY / 256           ;
                adc a,$00                       ;
                ld h,a                          ;

                ld b,(hl)                       ;

                ld hl,(YTurn)                   ;

                sra h                           ;
                rr l                            ;

                ld a,l                          ;
                xor $80                         ;
                ld l,a                          ;

                sra d                           ;
                rr e                            ;
                ld a,e                          ;

                xor $80                         ;
                cp 3                            ;

                jr nc,DrawSights1               ;

                ld a,3                          ;

                jp DrawSights3                  ;

DrawSights1     cp 251                          ;
                jr c,DrawSights3                ;

                ld a,251                        ;

DrawSights3     ld e,a                          ;

                ld h,DivTab / 256               ;
                ld a,(hl)                       ;

                sub 3                           ;
                jr nc,DrawSights3a              ;

                xor a                           ;

DrawSights3a    cp b                            ;
                jr c,DrawSights3b               ;

                ld a,b                          ;

DrawSights3b    ld l,a                          ;

                ld a,e                          ;
                sub 3                           ;
                rrca                            ;
                rrca                            ;
                rrca                            ;
                and $1F                         ;
                ld d,a                          ;
                ld a,e                          ;
                sub $03                         ;
                and $07                         ;
                add a,a                         ;
                add a,a                         ;
                add a,a                         ;
                add a,a                         ;
                ld c,a                          ;
                ld b,$00                        ;
                ld ix,Sights                    ;
                add ix,bc                       ;
                ld e,l                          ;
                ld hl,(SighDE)                  ;
                or a                            ;
                sbc hl,de                       ;
                ld a,l                          ;
                or h                            ;
                jr nz,PutS2                     ;
                push ix                         ;
                pop bc                          ;
                ld hl,(SighIX)                  ;
                or a                            ;
                sbc hl,bc                       ;
                ld a,l                          ;
                or h                            ;
                jr z,PutS1                      ;
PutS2           push ix                         ;
                push de                         ;
                call UnDrawSights               ;
                pop de                          ;
                pop ix                          ;
                ld (SighDE),de                  ;
                ld (SighIX),ix                  ;
PutS1           ld b,$07                        ;
PutClp          ld l,e                          ;
                ld h,YTable / 256               ;
                ld a,(hl)                       ;
                inc h                           ;
                ld h,(hl)                       ;
                add a,d                         ;
                ld l,a                          ;
                ld a,(ix)                       ;
                or (hl)                         ;
                ld (hl),a                       ;
                inc ix                          ;
                inc l                           ;
                ld a,(ix)                       ;
                or (hl)                         ;
                ld (hl),a                       ;
                inc e                           ;
                inc ix                          ;
                djnz PutClp                     ;
                ret                             ;

SightClipY      defb 159,159,161,185            ;

UnDrawSights    ld de,$0000                     ;
SighDE          equ .-2                         ;
                ld ix,$0000                     ;
SighIX          equ .-2                         ;

                ld b,7                          ;

RemClp          ld l,e                          ;
                ld h,YTable / 256               ;

                ld a,(hl)                       ;
                inc h                           ;
                ld h,(hl)                       ;
                add a,d                         ;
                ld l,a                          ;

                ld a,(ix)                       ;
                cpl                             ;
                and (hl)                        ;
                ld (hl),a                       ;
                inc ix                          ;
                inc l                           ;
                ld a,(ix)                       ;
                cpl                             ;
                and (hl)                        ;
                ld (hl),a                       ;
                inc e                           ;
                inc ix                          ;
                djnz RemClp                     ;
                ret                             ;

; The crossed ear-pokers, erm, guns sights.

Sights          dg ##---##---------             ;
                dg ##---##---------             ;
                dg --#-#-----------             ;
                dg ----------------             ;
                dg --#-#-----------             ;
                dg ##---##---------             ;
                dg ##---##---------             ;
                dg ----------------             ;

                dg -##---##--------             ;
                dg -##---##--------             ;
                dg ---#-#----------             ;
                dg ----------------             ;
                dg ---#-#----------             ;
                dg -##---##--------             ;
                dg -##---##--------             ;
                dg ----------------             ;

                dg --##---##-------             ;
                dg --##---##-------             ;
                dg ----#-#---------             ;
                dg ----------------             ;
                dg ----#-#---------             ;
                dg --##---##-------             ;
                dg --##---##-------             ;
                dg ----------------             ;

                dg ---##---##------             ;
                dg ---##---##------             ;
                dg -----#-#--------             ;
                dg ----------------             ;
                dg -----#-#--------             ;
                dg ---##---##------             ;
                dg ---##---##------             ;
                dg ----------------             ;

                dg ----##---##-----             ;
                dg ----##---##-----             ;
                dg ------#-#-------             ;
                dg ----------------             ;
                dg ------#-#-------             ;
                dg ----##---##-----             ;
                dg ----##---##-----             ;
                dg ----------------             ;

                dg -----##---##----             ;
                dg -----##---##----             ;
                dg -------#-#------             ;
                dg ----------------             ;
                dg -------#-#------             ;
                dg -----##---##----             ;
                dg -----##---##----             ;
                dg ----------------             ;

                dg ------##---##---             ;
                dg ------##---##---             ;
                dg --------#-#-----             ;
                dg ----------------             ;
                dg --------#-#-----             ;
                dg ------##---##---             ;
                dg ------##---##---             ;
                dg ----------------             ;

                dg -------##---##--             ;
                dg -------##---##--             ;
                dg ---------#-#----             ;
                dg ----------------             ;
                dg ---------#-#----             ;
                dg -------##---##--             ;
                dg -------##---##--             ;
                dg ----------------             ;

InitVars        ld hl,0                         ;
                ld (DeltaX),hl                  ;
                ld (DeltaY),hl                  ;
                ld (XTurn),hl                   ;
                ld (YTurn),hl                   ;

                ld hl,StartZ                    ;
                ld (DeltaZ),hl                  ;

                ld hl,0                         ;
                ld (GroundX),hl                 ;
                ld (GroundZ),hl                 ;

                ld hl,StartY                    ;
                ld (GroundY),hl                 ;

                xor a                           ;
                ld (OldX),a                     ;
                ld (OldY),a                     ;

                ld hl,$0F59                     ;
                ld (SighDE),hl                  ;

                ld hl,$A93F                     ;
                ld (SighIX),hl                  ;
                ret                             ;

; Added support for analog joystick (13/Mar/2012)

        if not enabled Original
bUseAnalogJS    ds 1                            ;
        endif

;  End of PLAYER
